#pragma once
#include <string>

using int32 = int;
using FString = std::string;

struct FBullCowCount {

	int32 Bulls = 0;
	int32 Cows = 0;
};

enum class EWordStatus {
	Invalid_Guess,
	OK,
	Not_Isogram,
	Wrong_length,
	Not_Lowercase
};

class FBullCowGame {
public:
	FBullCowGame();

	int32 GetMaxTries() const;
	int32 GetCurrentTry() const;
	int32 GetHiddenWordLength() const;
	FString GetHiddenWord();
	bool IsGameWon() const;		
	EWordStatus CheckGuessValidity(FString) const;	

	int32 SetHiddenWordbyDifficulty(int32);
	FString HiddenWordHint() const;

	void Reset();	
	FBullCowCount SubmitValidGuess(FString);

private:
	//See constructor for values
	int32 MyCurrentTries;
	FString MyHiddenWord;
	bool BIsWon;

	bool IsIsogram(FString) const;
	bool IsLowercase(FString) const;
};